<?php

namespace Drp\SimpleCms\Generators\Crud\SimpleCMS;

use Drp\SimpleCms\Generators\Crud\Core;

class Policy
{
    public static function create(string $type): void
    {
        $serviceProviderPath = base_path('app/Providers/AuthServiceProvider.php');
        $namespace = "namespace App\\Providers;\n\n";

        if (!Core::shouldModify($serviceProviderPath, "use App\\Models\\$type")) {
            return;
        }

        $use = $namespace . "use App\\Models\\$type;\nuse App\\Policies\\{$type}Policy;\n";

        $replace = [
            $namespace => $use,
            "protected \$policies = [\n" => "protected \$policies = [\n        $type::class => {$type}Policy::class,\n",
        ];

        $policies = str_replace(array_keys($replace), $replace, file_get_contents($serviceProviderPath));

        file_put_contents($serviceProviderPath, $policies);
    }
}
